Bug 1955618 - Review Request: perl-XS-Parse-Keyword - XS functions to assist in parsing keyword syntax
Summary: Review Request: perl-XS-Parse-Keyword - XS functions to assist in parsing key...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Peter Oliver
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1955588 1955989
TreeView+ depends on / blocked
 
Reported: 2021-04-30 14:38 UTC by Petr Pisar
Modified: 2021-05-06 11:11 UTC (History)
2 users (show)

Fixed In Version: perl-XS-Parse-Keyword-0.03-2.fc35
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-05-06 11:11:54 UTC
Type: ---
mavit: fedora-review+


Attachments (Terms of Use)

Description Petr Pisar 2021-04-30 14:38:13 UTC
Spec URL: https://ppisar.fedorapeople.org/perl-XS-Parse-Keyword/perl-XS-Parse-Keyword.spec
SRPM URL: https://ppisar.fedorapeople.org/perl-XS-Parse-Keyword/perl-XS-Parse-Keyword-0.03-1.fc35.src.rpm
Description:
This module provides some XS functions to assist in writing syntax modules
that provide new perl-visible syntax, primarily for authors of keyword plugins
using the PL_keyword_plugin hook mechanism.

Fedora Account System Username: ppisar

Comment 1 Peter Oliver 2021-05-03 15:28:39 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/#_macros
- It it useful to package the tests, rather than running them only at build
  time?
- The following message is issued during the build.  Are you sure it’s okay to
  leave out this dependency?

  Checking prerequisites...
    test_requires:
      !  Test::Fatal is not installed

  ERRORS/WARNINGS FOUND IN PREREQUISITES.  You may wish to install the versions
  of the modules indicated above before proceeding with this installation


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "The Perl 5 License GNU General Public
     License, version 1", "GNU General Public License". 25 files have
     unknown license. Detailed output of licensecheck in
     /home/mavit/src/fedora-review/1955618-perl-XS-Parse-
     Keyword/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[-]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/lib64/perl5/vendor_perl/XS(perl-XS-Parse-Sublike),
     /usr/lib64/perl5/vendor_perl/XS/Parse(perl-XS-Parse-Sublike),
     /usr/lib64/perl5/vendor_perl/auto/XS(perl-XS-Parse-Sublike),
     /usr/lib64/perl5/vendor_perl/auto/XS/Parse(perl-XS-Parse-Sublike)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Perl:
[x]: CPAN urls should be non-versioned.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: perl-XS-Parse-Keyword-0.03-1.fc34.x86_64.rpm
          perl-XS-Parse-Keyword-tests-0.03-1.fc34.x86_64.rpm
          perl-XS-Parse-Keyword-debuginfo-0.03-1.fc34.x86_64.rpm
          perl-XS-Parse-Keyword-debugsource-0.03-1.fc34.x86_64.rpm
          perl-XS-Parse-Keyword-0.03-1.fc34.src.rpm
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/build/build.so
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/pieces/pieces.so
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/stages/stages.so
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/structures/structures.so
perl-XS-Parse-Keyword-tests.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (debuginfo)
-------------------
Checking: perl-XS-Parse-Keyword-tests-debuginfo-0.03-1.fc34.x86_64.rpm
          perl-XS-Parse-Keyword-debuginfo-0.03-1.fc34.x86_64.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/build/build.so
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/pieces/pieces.so
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/stages/stages.so
perl-XS-Parse-Keyword-tests.x86_64: W: library-not-linked-against-libc /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/structures/structures.so
perl-XS-Parse-Keyword-tests.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 5 warnings.



Unversioned so-files
--------------------
perl-XS-Parse-Keyword: /usr/lib64/perl5/vendor_perl/auto/XS/Parse/Keyword/Keyword.so
perl-XS-Parse-Keyword-tests: /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/build/build.so
perl-XS-Parse-Keyword-tests: /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/pieces/pieces.so
perl-XS-Parse-Keyword-tests: /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/stages/stages.so
perl-XS-Parse-Keyword-tests: /usr/libexec/perl-XS-Parse-Keyword/t/blib/arch/auto/t/structures/structures.so

Source checksums
----------------
https://cpan.metacpan.org/authors/id/P/PE/PEVANS/XS-Parse-Keyword-0.03.tar.gz :
  CHECKSUM(SHA256) this package     : 539616c8a1c6702b5be986c547f3f59bfbe2f13fb7d32ac18e58a49c1c8d3373
  CHECKSUM(SHA256) upstream package : 539616c8a1c6702b5be986c547f3f59bfbe2f13fb7d32ac18e58a49c1c8d3373


Requires
--------
perl-XS-Parse-Keyword (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    perl(:MODULE_COMPAT_5.32.1)
    perl(:VERSION)
    perl(XSLoader)
    perl(warnings)
    rtld(GNU_HASH)

perl-XS-Parse-Keyword-tests (rpmlib, GLIBC filtered):
    /usr/bin/perl
    /usr/bin/sh
    libpthread.so.0()(64bit)
    perl(:VERSION)
    perl(Test::More)
    perl(XS::Parse::Keyword)
    perl(lib)
    perl(strict)
    perl(warnings)
    perl-Test-Harness
    perl-XS-Parse-Keyword(x86-64)
    rtld(GNU_HASH)

perl-XS-Parse-Keyword-debuginfo (rpmlib, GLIBC filtered):

perl-XS-Parse-Keyword-debugsource (rpmlib, GLIBC filtered):



Provides
--------
perl-XS-Parse-Keyword:
    perl(XS::Parse::Keyword)
    perl(XS::Parse::Keyword::Builder)
    perl-XS-Parse-Keyword
    perl-XS-Parse-Keyword(x86-64)

perl-XS-Parse-Keyword-tests:
    perl-XS-Parse-Keyword-tests
    perl-XS-Parse-Keyword-tests(x86-64)

perl-XS-Parse-Keyword-debuginfo:
    debuginfo(build-id)
    perl-XS-Parse-Keyword-debuginfo
    perl-XS-Parse-Keyword-debuginfo(x86-64)

perl-XS-Parse-Keyword-debugsource:
    perl-XS-Parse-Keyword-debugsource
    perl-XS-Parse-Keyword-debugsource(x86-64)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review --bug=1955618 -v --mock-config=fedora-34-x86_64
Buildroot used: fedora-34-x86_64
Active plugins: Perl, C/C++, Shell-api, Generic
Disabled plugins: SugarActivity, Haskell, R, fonts, Python, Ocaml, PHP, Java
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Petr Pisar 2021-05-03 16:47:29 UTC
(In reply to Peter Oliver from comment #1)
> - Package uses either %{buildroot} or $RPM_BUILD_ROOT
>   Note: Using both %{buildroot} and $RPM_BUILD_ROOT
>   See: https://docs.fedoraproject.org/en-US/packaging-guidelines/#_macros

Good catch. I updated the spec file to only use the macro form.

> - It it useful to package the tests, rather than running them only at build
>   time?

The packaged tests exhibit code installed into the system location, while
the tests run at a build-time exhibit code under in a nonsystem location.
These two can (e.g. by a mistake) differ. I use the package tests in gating
tests which are performed by Bodhi system.

Also the packaged tests can be run any later and validate the system on user's
request. E.g. when a dependency changes. This is superhandy when gating foreign
builds with tests of its reverse dependencies.

> - The following message is issued during the build.  Are you sure it’s okay
> to
>   leave out this dependency?
> 
>   Checking prerequisites...
>     test_requires:
>       !  Test::Fatal is not installed
> 
Yes. I'm pretty sure and upstream acknowledged it
<https://rt.cpan.org/Public/Bug/Display.html?id=136386>.

Comment 3 Peter Oliver 2021-05-03 18:01:57 UTC
Accepted!

Comment 5 Tomas Hrcka 2021-05-04 10:48:44 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/perl-XS-Parse-Keyword

Comment 6 Petr Pisar 2021-05-04 11:39:14 UTC
Thank you for the review and the repository.

Comment 7 Petr Pisar 2021-05-04 14:36:09 UTC
The gating fails because of a bug in perl. I will retry the gating once fixed perl-5.32.1-475.fc35 reaches the gating system.

Comment 8 Petr Pisar 2021-05-06 11:11:54 UTC
Gating passed with the new perl.


Note You need to log in before you can comment on or make changes to this bug.